#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/types.h>
#include </usr/src/linux/include/linux/pci.h>

int main(void)
{
        struct pci_access *pacc;
        struct pci_dev *dev;
        struct pci_dev *d;
        unsigned int idx, data=0x2080, idx2, idx3;
        pacc = pci_alloc();             /* Get the pci_access structure */
        /* Set all options you want -- here we stick with the defaults */
        pci_init(pacc);         /* Initialize the PCI library */
        pci_scan_bus(pacc);             /* We want to get the list of devices */

        if ((d = pci_get_dev(pacc, 0, 0, 0)))
            printf("PCI: device found\n");
        else
            printf("PCI: device not found \n");

        idx=pci_read_word(d, 0x06);
        printf("default read word 0x%x\n",idx);

        pci_write_word(d, 0x06, data);
        printf("changing reg val 0x%x\n",data);

        idx2=pci_read_word(d, 0x06);
        printf("reread word 1 0x%x\n",idx2);
        idx3=pci_read_word(d, 0x07);
        printf("reread word 2 0x%x\n",idx3);

        pci_cleanup(pacc);              /* Close everything */
        return(0);
}

